#include <LowPower.h>

int duty_cycle = 125;
int count = 0;

void setup() {
  
  
  //wait for input power to stabilise (5 seconds)
  delay(5000);
  //Serial.begin(9600);
  pinMode(A3, OUTPUT);
  pinMode(A4, OUTPUT);
  pinMode(3, OUTPUT);

}

void loop() {
  
  
  
   analogWrite(3, duty_cycle); /**send PWM signal to mosfet (note: arduino PWM frequency is too low for the 270uH inductor used, 
   a better approach would be to use a timer to produce a higher frequency PWM. This would reduce current ripple in the coil 
   and lower the maximum voltage applied to the battery, which could be useful on smaller batteries. **/
   
   //Serial.println(duty_cycle);
   
   delay(250); //run for 0.25 seconds
   optimise_duty_cycle(); //adjust duty cycle
   count++;

   if(duty_cycle == 0){
      LowPower.powerDown(SLEEP_8S, ADC_OFF, BOD_OFF); //sleep for 8 seconds in absence of solar energy input to save power
   }
   
   if(count == 40){ //every 10 seconds

    battery_guard(); //check if battery is full (overrides optimal DC)
    count = 0;
      
  }
   


}
